Index: /palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- /palm/trunk/SOURCE/salsa_mod.f90	(revision 3863)
+++ /palm/trunk/SOURCE/salsa_mod.f90	(revision 3864)
@@ -9627,23 +9560,489 @@
                    DO  k = nzb_do, nzt_do
                       temp_bin = 0.0_wp
-                      DO  b = 1, nbins
-!                      
+                      DO  ib = 1, nbins_aerosol
+!
 !--                      Diameter in micrometres
-                         mean_d = 1.0E+6_wp * Ra_dry(k,j,i,b) * 2.0_wp 
-!                               
-!--                      Deposition factor: alveolar                             
-                         df = ( 0.01555_wp / mean_d ) * ( EXP( -0.416_wp *     &
-                              ( LOG( mean_d ) + 2.84_wp )**2.0_wp ) + 19.11_wp &
-                              * EXP( -0.482_wp * ( LOG( mean_d ) - 1.362_wp    &
-                                )**2.0_wp ) )
-!                                    
+                         mean_d = 1.0E+6_wp * ra_dry(k,j,i,ib) * 2.0_wp 
+!
+!--                      Deposition factor: alveolar
+                         df = ( 0.01555_wp / mean_d ) * ( EXP( -0.416_wp * ( LOG( mean_d ) +       &
+                                2.84_wp )**2 ) + 19.11_wp * EXP( -0.482_wp * ( LOG( mean_d ) -     &
+                                1.362_wp )**2 ) )
+!
 !--                      Number concentration in 1/cm3
-                         nc = 1.0E-6_wp * aerosol_number(b)%conc(k,j,i)
-!                         
+                         nc = 1.0E-6_wp * aerosol_number(ib)%conc(k,j,i)
+!
 !--                      Lung-deposited surface area LDSA (units mum2/cm3)
-                         temp_bin = temp_bin + pi * mean_d**2.0_wp * df * nc 
+                         temp_bin = temp_bin + pi * mean_d**2 * df * nc
                       ENDDO
-                      local_pf(i,j,k) = MERGE( temp_bin,                       &
-                                               REAL( fill_value, KIND = wp ),  &
+
+                      local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value, KIND = wp ),            &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
+                   ENDDO
+                ENDDO
+             ENDDO
+          ELSE
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_do, nzt_do
+                      local_pf(i,j,k) = MERGE( ldsa_av(k,j,i), REAL( fill_value, KIND = wp ),      &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
+                   ENDDO
+                ENDDO
+             ENDDO
+          ENDIF
+
+          IF ( mode == 'xy' )  grid = 'zu'
+
+       CASE ( 'N_bin1', 'N_bin2', 'N_bin3', 'N_bin4',   'N_bin5',  'N_bin6', 'N_bin7', 'N_bin8',   &
+              'N_bin9', 'N_bin10' , 'N_bin11', 'N_bin12' )
+          vari = TRIM( variable( 6:LEN( TRIM( variable ) ) - 3 ) )
+
+          IF ( vari == '1' ) ib = 1
+          IF ( vari == '2' ) ib = 2
+          IF ( vari == '3' ) ib = 3
+          IF ( vari == '4' ) ib = 4
+          IF ( vari == '5' ) ib = 5
+          IF ( vari == '6' ) ib = 6
+          IF ( vari == '7' ) ib = 7
+          IF ( vari == '8' ) ib = 8
+          IF ( vari == '9' ) ib = 9
+          IF ( vari == '10' ) ib = 10
+          IF ( vari == '11' ) ib = 11
+          IF ( vari == '12' ) ib = 12
+
+          IF ( av == 0 )  THEN
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_do, nzt_do
+                      local_pf(i,j,k) = MERGE( aerosol_number(ib)%conc(k,j,i), REAL( fill_value,   &
+                                               KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) )
+                   ENDDO
+                ENDDO
+             ENDDO
+          ELSE
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_do, nzt_do
+                      local_pf(i,j,k) = MERGE( nbins_av(k,j,i,ib), REAL( fill_value, KIND = wp ),  &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
+                   ENDDO
+                ENDDO
+             ENDDO
+          ENDIF
+
+          IF ( mode == 'xy' )  grid = 'zu'
+
+       CASE ( 'Ntot' )
+
+          IF ( av == 0 )  THEN
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_do, nzt_do
+                      temp_bin = 0.0_wp
+                      DO  ib = 1, nbins_aerosol
+                         temp_bin = temp_bin + aerosol_number(ib)%conc(k,j,i)
+                      ENDDO
+                      local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value, KIND = wp ),            &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
+                   ENDDO
+                ENDDO
+             ENDDO
+          ELSE
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_do, nzt_do
+                      local_pf(i,j,k) = MERGE( ntot_av(k,j,i), REAL( fill_value, KIND = wp ),      &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
+                   ENDDO
+                ENDDO
+             ENDDO
+          ENDIF
+
+          IF ( mode == 'xy' )  grid = 'zu'
+
+       CASE ( 'm_bin1', 'm_bin2', 'm_bin3', 'm_bin4',   'm_bin5',  'm_bin6', 'm_bin7', 'm_bin8',   &
+              'm_bin9', 'm_bin10' , 'm_bin11', 'm_bin12' )
+          vari = TRIM( variable( 6:LEN( TRIM( variable ) ) - 3 ) )
+
+          IF ( vari == '1' ) ib = 1
+          IF ( vari == '2' ) ib = 2
+          IF ( vari == '3' ) ib = 3
+          IF ( vari == '4' ) ib = 4
+          IF ( vari == '5' ) ib = 5
+          IF ( vari == '6' ) ib = 6
+          IF ( vari == '7' ) ib = 7
+          IF ( vari == '8' ) ib = 8
+          IF ( vari == '9' ) ib = 9
+          IF ( vari == '10' ) ib = 10
+          IF ( vari == '11' ) ib = 11
+          IF ( vari == '12' ) ib = 12
+
+          IF ( av == 0 )  THEN
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_do, nzt_do
+                      temp_bin = 0.0_wp
+                      DO  ic = ib, ncomponents_mass * nbins_aerosol, nbins_aerosol
+                         temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
+                      ENDDO
+                      local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value, KIND = wp ),            &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
+                   ENDDO
+                ENDDO
+             ENDDO
+          ELSE
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_do, nzt_do
+                      local_pf(i,j,k) = MERGE( mbins_av(k,j,i,ib), REAL( fill_value, KIND = wp ),  &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
+                   ENDDO
+                ENDDO
+             ENDDO
+          ENDIF
+
+          IF ( mode == 'xy' )  grid = 'zu'
+
+       CASE ( 'PM2.5' )
+          IF ( av == 0 )  THEN
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_do, nzt_do
+                      temp_bin = 0.0_wp
+                      DO  ib = 1, nbins_aerosol
+                         IF ( 2.0_wp * ra_dry(k,j,i,ib) <= 2.5E-6_wp )  THEN
+                            DO  ic = ib, nbins_aerosol * ncc, nbins_aerosol
+                               temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
+                            ENDDO
+                         ENDIF
+                      ENDDO
+                      local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value, KIND = wp ),            &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
+                   ENDDO
+                ENDDO
+             ENDDO
+          ELSE
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_do, nzt_do
+                      local_pf(i,j,k) = MERGE( pm25_av(k,j,i), REAL( fill_value, KIND = wp ),      &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
+                   ENDDO
+                ENDDO
+             ENDDO
+          ENDIF
+
+          IF ( mode == 'xy' )  grid = 'zu'
+
+       CASE ( 'PM10' )
+          IF ( av == 0 )  THEN
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_do, nzt_do
+                      temp_bin = 0.0_wp
+                      DO  ib = 1, nbins_aerosol
+                         IF ( 2.0_wp * ra_dry(k,j,i,ib) <= 10.0E-6_wp )  THEN
+                            DO  ic = ib, nbins_aerosol * ncc, nbins_aerosol
+                               temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
+                            ENDDO
+                         ENDIF
+                      ENDDO
+                      local_pf(i,j,k) = MERGE( temp_bin,  REAL( fill_value, KIND = wp ),           &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
+                   ENDDO
+                ENDDO
+             ENDDO
+          ELSE
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_do, nzt_do
+                      local_pf(i,j,k) = MERGE( pm10_av(k,j,i), REAL( fill_value, KIND = wp ),      &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
+                   ENDDO
+                ENDDO
+             ENDDO
+          ENDIF
+
+          IF ( mode == 'xy' )  grid = 'zu'
+
+       CASE ( 's_BC', 's_DU', 's_H2O', 's_NH', 's_NO', 's_OC', 's_SO4', 's_SS' )
+          vari = TRIM( variable( 3:LEN( TRIM( variable ) ) - 3 ) )
+          IF ( is_used( prtcl, vari ) )  THEN
+             found_index = get_index( prtcl, vari )
+             IF ( av == 0 )  THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb_do, nzt_do
+                         temp_bin = 0.0_wp
+                         DO  ic = ( found_index-1 ) * nbins_aerosol+1, found_index * nbins_aerosol
+                            temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
+                         ENDDO
+                         local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value, KIND = wp ),         &
+                                                  BTEST( wall_flags_0(k,j,i), 0 ) )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ELSE
+                IF ( vari == 'BC' )   to_be_resorted => s_bc_av
+                IF ( vari == 'DU' )   to_be_resorted => s_du_av
+                IF ( vari == 'NH' )   to_be_resorted => s_nh_av
+                IF ( vari == 'NO' )   to_be_resorted => s_no_av
+                IF ( vari == 'OC' )   to_be_resorted => s_oc_av
+                IF ( vari == 'SO4' )  to_be_resorted => s_so4_av
+                IF ( vari == 'SS' )   to_be_resorted => s_ss_av
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb_do, nzt_do
+                         local_pf(i,j,k) = MERGE( to_be_resorted(k,j,i), REAL( fill_value,         &
+                                                  KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
+          ELSE
+             local_pf = fill_value
+          ENDIF
+
+          IF ( mode == 'xy' )  grid = 'zu'
+
+       CASE DEFAULT
+          found = .FALSE.
+          grid  = 'none'
+
+    END SELECT
+
+ END SUBROUTINE salsa_data_output_2d
+
+!------------------------------------------------------------------------------!
+!
+! Description:
+! ------------
+!> Subroutine defining 3D output variables
+!------------------------------------------------------------------------------!
+ SUBROUTINE salsa_data_output_3d( av, variable, found, local_pf, nzb_do, nzt_do )
+
+    USE indices
+
+    USE kinds
+
+
+    IMPLICIT NONE
+
+    CHARACTER(LEN=*), INTENT(in) ::  variable   !<
+
+    INTEGER(iwp) ::  av           !<
+    INTEGER(iwp) ::  found_index  !< index of a chemical compound
+    INTEGER(iwp) ::  ib           !< running index: size bins
+    INTEGER(iwp) ::  ic           !< running index: mass bins
+    INTEGER(iwp) ::  i            !<
+    INTEGER(iwp) ::  j            !<
+    INTEGER(iwp) ::  k            !<
+    INTEGER(iwp) ::  nzb_do       !<
+    INTEGER(iwp) ::  nzt_do       !<
+
+    LOGICAL ::  found      !<
+
+    REAL(wp) ::  df                       !< For calculating LDSA: fraction of particles
+                                          !< depositing in the alveolar (or tracheobronchial)
+                                          !< region of the lung. Depends on the particle size
+    REAL(wp) ::  fill_value = -9999.0_wp  !< value for the _FillValue attribute
+    REAL(wp) ::  mean_d                   !< Particle diameter in micrometres
+    REAL(wp) ::  nc                       !< Particle number concentration in units 1/cm**3
+    REAL(wp) ::  temp_bin                 !< temporary array for calculating output variables
+
+    REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf  !< local
+
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  to_be_resorted  !< pointer
+
+    found     = .TRUE.
+    temp_bin  = 0.0_wp
+
+    SELECT CASE ( TRIM( variable ) )
+
+       CASE ( 'g_H2SO4', 'g_HNO3', 'g_NH3', 'g_OCNV',  'g_OCSV' )
+          IF ( av == 0 )  THEN
+             IF ( TRIM( variable ) == 'g_H2SO4')  found_index = 1
+             IF ( TRIM( variable ) == 'g_HNO3')   found_index = 2
+             IF ( TRIM( variable ) == 'g_NH3')    found_index = 3
+             IF ( TRIM( variable ) == 'g_OCNV')   found_index = 4
+             IF ( TRIM( variable ) == 'g_OCSV')   found_index = 5
+
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_do, nzt_do
+                      local_pf(i,j,k) = MERGE( salsa_gas(found_index)%conc(k,j,i),                 &
+                                               REAL( fill_value, KIND = wp ),                      &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
+                   ENDDO
+                ENDDO
+             ENDDO
+          ELSE
+             IF ( TRIM( variable(3:) ) == 'H2SO4' ) to_be_resorted => g_h2so4_av
+             IF ( TRIM( variable(3:) ) == 'HNO3' )  to_be_resorted => g_hno3_av
+             IF ( TRIM( variable(3:) ) == 'NH3' )   to_be_resorted => g_nh3_av
+             IF ( TRIM( variable(3:) ) == 'OCNV' )  to_be_resorted => g_ocnv_av
+             IF ( TRIM( variable(3:) ) == 'OCSV' )  to_be_resorted => g_ocsv_av
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_do, nzt_do
+                      local_pf(i,j,k) = MERGE( to_be_resorted(k,j,i), REAL( fill_value,            &
+                                               KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) )
+                   ENDDO
+                ENDDO
+             ENDDO
+          ENDIF
+
+       CASE ( 'LDSA' )
+          IF ( av == 0 )  THEN
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_do, nzt_do
+                      temp_bin = 0.0_wp
+                      DO  ib = 1, nbins_aerosol
+!
+!--                      Diameter in micrometres
+                         mean_d = 1.0E+6_wp * ra_dry(k,j,i,ib) * 2.0_wp
+!
+!--                      Deposition factor: alveolar
+                         df = ( 0.01555_wp / mean_d ) * ( EXP( -0.416_wp * ( LOG( mean_d ) +       &
+                                2.84_wp )**2 ) + 19.11_wp * EXP( -0.482_wp * ( LOG( mean_d ) -     &
+                                1.362_wp )**2 ) )
+!
+!--                      Number concentration in 1/cm3
+                         nc = 1.0E-6_wp * aerosol_number(ib)%conc(k,j,i)
+!
+!--                      Lung-deposited surface area LDSA (units mum2/cm3)
+                         temp_bin = temp_bin + pi * mean_d**2 * df * nc 
+                      ENDDO
+                      local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value, KIND = wp ),            &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
+                   ENDDO
+                ENDDO
+             ENDDO
+          ELSE
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_do, nzt_do
+                      local_pf(i,j,k) = MERGE( ldsa_av(k,j,i), REAL( fill_value, KIND = wp ),      &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
+                   ENDDO
+                ENDDO
+             ENDDO
+          ENDIF
+
+       CASE ( 'N_bin1', 'N_bin2', 'N_bin3', 'N_bin4', 'N_bin5', 'N_bin6', 'N_bin7', 'N_bin8',      &
+              'N_bin9', 'N_bin10', 'N_bin11', 'N_bin12' )
+          IF ( TRIM( variable(6:) ) == '1' ) ib = 1
+          IF ( TRIM( variable(6:) ) == '2' ) ib = 2
+          IF ( TRIM( variable(6:) ) == '3' ) ib = 3
+          IF ( TRIM( variable(6:) ) == '4' ) ib = 4
+          IF ( TRIM( variable(6:) ) == '5' ) ib = 5
+          IF ( TRIM( variable(6:) ) == '6' ) ib = 6
+          IF ( TRIM( variable(6:) ) == '7' ) ib = 7
+          IF ( TRIM( variable(6:) ) == '8' ) ib = 8
+          IF ( TRIM( variable(6:) ) == '9' ) ib = 9
+          IF ( TRIM( variable(6:) ) == '10' ) ib = 10
+          IF ( TRIM( variable(6:) ) == '11' ) ib = 11
+          IF ( TRIM( variable(6:) ) == '12' ) ib = 12
+
+          IF ( av == 0 )  THEN
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_do, nzt_do
+                      local_pf(i,j,k) = MERGE( aerosol_number(ib)%conc(k,j,i), REAL( fill_value,   &
+                                               KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) )
+                   ENDDO
+                ENDDO
+             ENDDO
+          ELSE
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_do, nzt_do
+                      local_pf(i,j,k) = MERGE( nbins_av(k,j,i,ib), REAL( fill_value, KIND = wp ),  &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
+                   ENDDO
+                ENDDO
+             ENDDO
+          ENDIF
+
+       CASE ( 'Ntot' )
+          IF ( av == 0 )  THEN
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_do, nzt_do
+                      temp_bin = 0.0_wp
+                      DO  ib = 1, nbins_aerosol
+                         temp_bin = temp_bin + aerosol_number(ib)%conc(k,j,i)
+                      ENDDO
+                      local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value, KIND = wp ),            &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
+                   ENDDO
+                ENDDO
+             ENDDO
+          ELSE
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_do, nzt_do
+                      local_pf(i,j,k) = MERGE( ntot_av(k,j,i), REAL( fill_value, KIND = wp ),      &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
+                   ENDDO
+                ENDDO
+             ENDDO
+          ENDIF
+
+       CASE ( 'm_bin1', 'm_bin2', 'm_bin3', 'm_bin4', 'm_bin5', 'm_bin6', 'm_bin7', 'm_bin8',      &
+              'm_bin9', 'm_bin10' , 'm_bin11', 'm_bin12' )
+          IF ( TRIM( variable(6:) ) == '1' ) ib = 1
+          IF ( TRIM( variable(6:) ) == '2' ) ib = 2
+          IF ( TRIM( variable(6:) ) == '3' ) ib = 3
+          IF ( TRIM( variable(6:) ) == '4' ) ib = 4
+          IF ( TRIM( variable(6:) ) == '5' ) ib = 5
+          IF ( TRIM( variable(6:) ) == '6' ) ib = 6
+          IF ( TRIM( variable(6:) ) == '7' ) ib = 7
+          IF ( TRIM( variable(6:) ) == '8' ) ib = 8
+          IF ( TRIM( variable(6:) ) == '9' ) ib = 9
+          IF ( TRIM( variable(6:) ) == '10' ) ib = 10
+          IF ( TRIM( variable(6:) ) == '11' ) ib = 11
+          IF ( TRIM( variable(6:) ) == '12' ) ib = 12
+
+          IF ( av == 0 )  THEN
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_do, nzt_do
+                      temp_bin = 0.0_wp
+                      DO  ic = ib, ncomponents_mass * nbins_aerosol, nbins_aerosol
+                         temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
+                      ENDDO
+                      local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value, KIND = wp ),            &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
+                   ENDDO
+                ENDDO
+             ENDDO
+          ELSE
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_do, nzt_do
+                      local_pf(i,j,k) = MERGE( mbins_av(k,j,i,ib), REAL( fill_value, KIND = wp ),  &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
+                   ENDDO
+                ENDDO
+             ENDDO
+          ENDIF
+
+       CASE ( 'PM2.5' )
+          IF ( av == 0 )  THEN
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_do, nzt_do
+                      temp_bin = 0.0_wp
+                      DO  ib = 1, nbins_aerosol
+                         IF ( 2.0_wp * ra_dry(k,j,i,ib) <= 2.5E-6_wp )  THEN
+                            DO  ic = ib, nbins_aerosol * ncc, nbins_aerosol
+                               temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
+                            ENDDO
+                         ENDIF
+                      ENDDO
+                      local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value, KIND = wp ),            &
                                                BTEST( wall_flags_0(k,j,i), 0 ) ) 
                    ENDDO
@@ -9654,6 +10053,5 @@
                 DO  j = nys, nyn
                    DO  k = nzb_do, nzt_do
-                      local_pf(i,j,k) = MERGE( LDSA_av(k,j,i),                 &
-                                               REAL( fill_value, KIND = wp ),  &
+                      local_pf(i,j,k) = MERGE( pm25_av(k,j,i), REAL( fill_value, KIND = wp ),      &
                                                BTEST( wall_flags_0(k,j,i), 0 ) ) 
                    ENDDO
@@ -9661,43 +10059,6 @@
              ENDDO
           ENDIF
-          
-       CASE ( 'N_bin1', 'N_bin2', 'N_bin3', 'N_bin4',   'N_bin5',  'N_bin6',   &
-              'N_bin7', 'N_bin8', 'N_bin9', 'N_bin10' , 'N_bin11', 'N_bin12' )
-          IF ( TRIM( variable(6:) ) == '1' ) b = 1
-          IF ( TRIM( variable(6:) ) == '2' ) b = 2
-          IF ( TRIM( variable(6:) ) == '3' ) b = 3
-          IF ( TRIM( variable(6:) ) == '4' ) b = 4
-          IF ( TRIM( variable(6:) ) == '5' ) b = 5
-          IF ( TRIM( variable(6:) ) == '6' ) b = 6
-          IF ( TRIM( variable(6:) ) == '7' ) b = 7
-          IF ( TRIM( variable(6:) ) == '8' ) b = 8
-          IF ( TRIM( variable(6:) ) == '9' ) b = 9
-          IF ( TRIM( variable(6:) ) == '10' ) b = 10
-          IF ( TRIM( variable(6:) ) == '11' ) b = 11
-          IF ( TRIM( variable(6:) ) == '12' ) b = 12
-          
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb_do, nzt_do                      
-                      local_pf(i,j,k) = MERGE( aerosol_number(b)%conc(k,j,i),  &
-                                               REAL( fill_value, KIND = wp ),  &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb_do, nzt_do                      
-                      local_pf(i,j,k) = MERGE( Nbins_av(k,j,i,b),              &
-                                               REAL( fill_value, KIND = wp ),  &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-          
-       CASE ( 'Ntot' )
+
+       CASE ( 'PM10' )
           IF ( av == 0 )  THEN
              DO  i = nxl, nxr
@@ -9705,9 +10066,12 @@
                    DO  k = nzb_do, nzt_do
                       temp_bin = 0.0_wp
-                      DO  b = 1, nbins                         
-                         temp_bin = temp_bin + aerosol_number(b)%conc(k,j,i)
+                      DO  ib = 1, nbins_aerosol
+                         IF ( 2.0_wp * ra_dry(k,j,i,ib) <= 10.0E-6_wp )  THEN
+                            DO  ic = ib, nbins_aerosol * ncc, nbins_aerosol
+                               temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
+                            ENDDO
+                         ENDIF
                       ENDDO
-                      local_pf(i,j,k) = MERGE( temp_bin,                       &
-                                               REAL( fill_value, KIND = wp ),  &
+                      local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value, KIND = wp ),            &
                                                BTEST( wall_flags_0(k,j,i), 0 ) ) 
                    ENDDO
@@ -9718,118 +10082,14 @@
                 DO  j = nys, nyn
                    DO  k = nzb_do, nzt_do
-                      local_pf(i,j,k) = MERGE( Ntot_av(k,j,i),                 &
-                                               REAL( fill_value, KIND = wp ),  &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
+                      local_pf(i,j,k) = MERGE( pm10_av(k,j,i), REAL( fill_value, KIND = wp ),      &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
                    ENDDO
                 ENDDO
              ENDDO
           ENDIF
-          
-       CASE ( 'm_bin1', 'm_bin2', 'm_bin3', 'm_bin4',   'm_bin5',  'm_bin6',   &
-              'm_bin7', 'm_bin8', 'm_bin9', 'm_bin10' , 'm_bin11', 'm_bin12' )
-          IF ( TRIM( variable(6:) ) == '1' ) b = 1
-          IF ( TRIM( variable(6:) ) == '2' ) b = 2
-          IF ( TRIM( variable(6:) ) == '3' ) b = 3
-          IF ( TRIM( variable(6:) ) == '4' ) b = 4
-          IF ( TRIM( variable(6:) ) == '5' ) b = 5
-          IF ( TRIM( variable(6:) ) == '6' ) b = 6
-          IF ( TRIM( variable(6:) ) == '7' ) b = 7
-          IF ( TRIM( variable(6:) ) == '8' ) b = 8
-          IF ( TRIM( variable(6:) ) == '9' ) b = 9
-          IF ( TRIM( variable(6:) ) == '10' ) b = 10
-          IF ( TRIM( variable(6:) ) == '11' ) b = 11
-          IF ( TRIM( variable(6:) ) == '12' ) b = 12
-          
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb_do, nzt_do   
-                      temp_bin = 0.0_wp
-                      DO  c = b, ncc_tot * nbins, nbins
-                         temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
-                      ENDDO
-                      local_pf(i,j,k) = MERGE( temp_bin,                       &
-                                               REAL( fill_value, KIND = wp ),  &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb_do, nzt_do                      
-                      local_pf(i,j,k) = MERGE( mbins_av(k,j,i,b),              &
-                                               REAL( fill_value, KIND = wp ),  &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-          
-       CASE ( 'PM2.5' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb_do, nzt_do
-                      temp_bin = 0.0_wp
-                      DO  b = 1, nbins
-                         IF ( 2.0_wp * Ra_dry(k,j,i,b) <= 2.5E-6_wp )  THEN
-                            DO  c = b, nbins * ncc, nbins
-                               temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
-                            ENDDO
-                         ENDIF
-                      ENDDO
-                      local_pf(i,j,k) = MERGE( temp_bin,                       &
-                                               REAL( fill_value, KIND = wp ),  &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb_do, nzt_do
-                      local_pf(i,j,k) = MERGE( PM25_av(k,j,i),                 &
-                                               REAL( fill_value, KIND = wp ),  &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-          
-       CASE ( 'PM10' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb_do, nzt_do
-                      temp_bin = 0.0_wp
-                      DO  b = 1, nbins
-                         IF ( 2.0_wp * Ra_dry(k,j,i,b) <= 10.0E-6_wp )  THEN
-                            DO  c = b, nbins * ncc, nbins
-                               temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
-                            ENDDO
-                         ENDIF
-                      ENDDO
-                      local_pf(i,j,k) = MERGE( temp_bin,                       &
-                                               REAL( fill_value, KIND = wp ),  &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb_do, nzt_do
-                      local_pf(i,j,k) = MERGE( PM10_av(k,j,i),                 &
-                                               REAL( fill_value, KIND = wp ),  &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-                 
+
        CASE ( 's_BC', 's_DU', 's_H2O', 's_NH', 's_NO', 's_OC', 's_SO4', 's_SS' )
           IF ( is_used( prtcl, TRIM( variable(3:) ) ) )  THEN
-             icc = get_index( prtcl, TRIM( variable(3:) ) )
+             found_index = get_index( prtcl, TRIM( variable(3:) ) )
              IF ( av == 0 )  THEN
                 DO  i = nxl, nxr
